﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.CellType;
using Appearance = FarPoint.Win.Spread.Appearance;

namespace Ist.CS.CustomControl.FarPointCustomCellTypes
{
    public class IST_MultiCheckBoxCellType : ICellType
    {
        private MultiCheckBox multiCheckBox = null;

        public IST_MultiCheckBoxCellType()
        {
            // create new internal control
            multiCheckBox = new MultiCheckBox();

            // subscribe change event
            multiCheckBox.CheckBoxCheckedStateChanged += new MultiCheckBox.CheckBoxCheckedStateChangedEventHandler(multiCheckBox_CheckBoxCheckedStateChanged);
        }

        /// <summary>
        /// state change event of internal multi-check-box control
        /// </summary>
        /// <param name="ItemID">id of state-changed checkbox</param>
        /// <param name="FlagID">flag id of state-changed checkbox</param>
        /// <param name="Checked">checked state of state-changed checkbox</param>
        void multiCheckBox_CheckBoxCheckedStateChanged(int ItemID, int FlagID, bool Checked)
        {
            
        }

        public void Init(List<MultiCheckBoxItem> MultiCheckBoxItems)
        {
            multiCheckBox.Init(MultiCheckBoxItems);
        }

        #region Implementation of IEditor

        public Control GetEditorControl(Appearance appearance, float zoomFactor)
        {
            return null;
        }

        public object GetEditorValue()
        {
            return multiCheckBox.CompositeValue;
        }

        public void ShowSubEditor()
        {
            return;
        }

        public void SetEditorValue(object value)
        {
            if (value is int)
            {
                multiCheckBox.CompositeValue = (int) value;
            }
        }

        public void StartEditing(EventArgs e, bool selectAll, bool autoClipboard)
        {
            return;
        }

        public void CancelEditing()
        {
            return;
        }

        public bool StopEditing()
        {
            return true;
        }

        public bool IsReservedKey(KeyEventArgs e)
        {
            return false;
        }

        public object IsReservedLocation(Graphics g, int x, int y, Rectangle rc, Appearance appearance, object value, float zoomFactor)
        {
            return this;
        }

        public bool IsValid(object value)
        {
            return true;
        }

        public Cursor GetReservedCursor(object o)
        {
            return null;
        }

        public Size GetPreferredSize(Control editor)
        {
            return multiCheckBox.Size;
        }

        public event EventHandler EditingCanceled;
        public event EventHandler EditingStopped;

        #endregion

        #region Implementation of IRenderer

        public Size GetPreferredSize(Graphics g, Size size, Appearance appearance, object value, float zoomFactor)
        {
            return multiCheckBox.Size;
        }

        public void PaintCell(Graphics g, Rectangle r, Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
        {
            multiCheckBox.Show();
        }

        public bool CanOverflow()
        {
            return true;
        }

        public bool CanBeOverflown()
        {
            return true;
        }

        #endregion

        #region Implementation of IFormatter

        public string Format(object o)
        {
            return "";
        }

        public object Parse(string s)
        {
            return s;
        }

        #endregion
    }
}
